
/////////////////////////////////////////////////////////////
//
// Source file for MainForm
//
//    This file is generated by RapidApp 1.1
//
//    This class is derived from MainFormUI which 
//    implements the user interface created in 
//    the interface builder. This class contains virtual
//    functions that are called from the user interface.
//
//    When you modify this source, limit your changes to 
//    modifying the sections between the "//--- Start/End editable code block" markers
//
//    This will allow the builder to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
/////////////////////////////////////////////////////////////

#include "MainForm.h"
#include "MainWindowMainWindow.h"
#include "ChatWindowMainWindow.h"
#include "OptionsWindowMainWindow.h"
#include "StatWindowMainWindow.h"
#include "CallWindowMainWindow.h"

#include <stdlib.h>
#include <stdio.h>
#include <Vk/VkEZ.h>
#include <Xm/Form.h> 
#include <Xm/Frame.h> 
#include <Xm/Label.h> 
#include <Xm/LabelG.h> 
#include <Xm/List.h> 
#include <Xm/PushB.h> 
#include <Xm/Scale.h> 
#include <Xm/ScrolledW.h> 
#include <Xm/TextF.h> 
#include <Xm/ToggleB.h> 
#include <Vk/VkResource.h>


// Externally defined classes referenced by this class:

#include <Vk/VkVuMeter.h>
#include <Vk/VkWindow.h>
#include <Vk/VkMenuBar.h>
#include <Vk/VkSubMenu.h>

extern void VkUnimplemented(Widget, const char *);

///////////////////////////////////////////////////////////////////////////////
// The following non-container widgets are created by MainFormUI and are
// available as protected data members inherited by this class
//
//  XmToggleButton (LED style)		    _toggle
//  XmTextField		    _statusText
//  XmLabelGadget		    _label1
//  XmLabel		    _label13
//  XmLabel		    _label12
//  XmToggleButton (LED style)		    _talkToggle
//  XmToggleButton		    _manualToggle
//  XmLabelGadget		    _label3
//  XmToggleButton		    _autoToggle
//  XmScale		    _speakerScale
//  XmScale		    _micScale
//  XmLabelGadget		    _label2
//  XmLabelGadget		    _label
//  XmList		    _usersList
//  XmPushButton		    _rejectButton
//  XmPushButton		    _acceptButton
//  XmPushButton		    _callButton
//
// The following components are created by MainFormUI and are
// available as protected data members inherited by this class
//
//  VkVuMeter		   *_speakerMeter
//  VkVuMeter		   *_micMeter
//
///////////////////////////////////////////////////////////////////////////////


//---- Start editable code block: headers and declarations

#include "BV_Session_Control.h"
#include "BV_Member.h"

//---- End editable code block: headers and declarations



//---- MainForm Constructor

MainForm::MainForm(const char *name, Widget parent) : 
                   MainFormUI(name, parent) 
{ 
    // This constructor calls MainFormUI(parent, name)
    // which calls MainFormUI::create() to create
    // the widgets for this component. Any code added here
    // is called after the component's interface has been built

    //---- Start editable code block: MainForm constructor

  XtSetSensitive(_acceptButton, False);
  XtSetSensitive(_rejectButton, False);

  _chat = new ChatWindowMainWindow("Chat", NULL, 0);

    //---- End editable code block: MainForm constructor



} // End Constructor



MainForm::MainForm(const char *name) : 
                   MainFormUI(name) 
 { 
    // This constructor calls MainFormUI(name)
    // which does not create any widgets. Usually, this
    // constructor is not used

    //---- Start editable code block: MainForm constructor 2

   XtSetSensitive(_acceptButton, False);
   XtSetSensitive(_rejectButton, False);

   _chat = new ChatWindowMainWindow("Chat", NULL, 0);

    //---- End editable code block: MainForm constructor 2



} // End Constructor



MainForm::~MainForm()
{
    // The base class destructors are responsible for
    // destroying all widgets and objects used in this component.
    // Only additional items created directly in this class
    // need to be freed here.

    //---- Start editable code block: MainForm destructor

  delete _chat;

    //---- End editable code block: MainForm destructor



}


const char * MainForm::className() // classname
{
    return ("MainForm");
} // End className()


void MainForm::accept ( Widget w, XtPointer callData )
{
    //---- Start editable code block: MainForm accept

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when MainForm::accept is implemented:

    //::VkUnimplemented ( w, "MainForm::accept" );

    BV_Session_Control *ctrl = BV_Session_Control::instance();
    ctrl->accept_invitation();
    ctrl->destroy();
    XtSetSensitive(_acceptButton, False);
    XtSetSensitive(_rejectButton, False);

    //---- End editable code block: MainForm accept

} // End MainForm::accept()


void MainForm::autoSwitch ( Widget w, XtPointer callData )
{
    //---- Start editable code block: MainForm autoSwitch

    XmToggleButtonCallbackStruct *cbs = (XmToggleButtonCallbackStruct*) callData;

    //--- Comment out the following line when MainForm::autoSwitch is implemented:

    ::VkUnimplemented ( w, "MainForm::autoSwitch" );




    //---- End editable code block: MainForm autoSwitch

} // End MainForm::autoSwitch()


void MainForm::call ( Widget w, XtPointer callData )
{
    //---- Start editable code block: MainForm call

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when MainForm::call is implemented:

    //::VkUnimplemented ( w, "MainForm::call" );

    VkSimpleWindow *callWindow  = new CallWindowMainWindow("callWindow");
    callWindow->show();    

    //---- End editable code block: MainForm call

} // End MainForm::call()


void MainForm::camera ( Widget w, XtPointer callData )
{
    //---- Start editable code block: MainForm camera

    XmToggleButtonCallbackStruct *cbs = (XmToggleButtonCallbackStruct*) callData;

    //--- Comment out the following line when MainForm::camera is implemented:

    //::VkUnimplemented ( w, "MainForm::camera" );

    if(XmToggleButtonGetState(w))
      ((MainWindowMainWindow *)_parent)->playVideo();
    else
      ((MainWindowMainWindow *)_parent)->stopVideo();      

    //---- End editable code block: MainForm camera

} // End MainForm::camera()


void MainForm::manualSwitch ( Widget w, XtPointer callData )
{
    //---- Start editable code block: MainForm manualSwitch

    XmToggleButtonCallbackStruct *cbs = (XmToggleButtonCallbackStruct*) callData;

    //--- Comment out the following line when MainForm::manualSwitch is implemented:

    //::VkUnimplemented ( w, "MainForm::manualSwitch" );


    if(!XmToggleButtonGetState(w))
      ((MainWindowMainWindow *)_parent)->playAudio();      

    //---- End editable code block: MainForm manualSwitch

} // End MainForm::manualSwitch()


void MainForm::reject ( Widget w, XtPointer callData )
{
    //---- Start editable code block: MainForm reject

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when MainForm::reject is implemented:

    //::VkUnimplemented ( w, "MainForm::reject" );

    BV_Session_Control *ctrl = BV_Session_Control::instance();
    ctrl->reject_invitation();
    ctrl->destroy();
    XtSetSensitive(_acceptButton, False);
    XtSetSensitive(_rejectButton, False);

    //---- End editable code block: MainForm reject

} // End MainForm::reject()


void MainForm::talk ( Widget w, XtPointer callData )
{
    //---- Start editable code block: MainForm talk

    XmToggleButtonCallbackStruct *cbs = (XmToggleButtonCallbackStruct*) callData;

    //--- Comment out the following line when MainForm::talk is implemented:

    //::VkUnimplemented ( w, "MainForm::talk" );

    if(XmToggleButtonGetState(_manualToggle))
      if(XmToggleButtonGetState(w))
	((MainWindowMainWindow *)_parent)->playAudio();
      else
	((MainWindowMainWindow *)_parent)->stopAudio();      
	


    //---- End editable code block: MainForm talk

} // End MainForm::talk()


void MainForm::userSelected ( Widget w, XtPointer callData )
{
    //---- Start editable code block: MainForm userSelected

    XmListCallbackStruct *cbs = (XmListCallbackStruct*) callData;

    //--- Comment out the following line when MainForm::userSelected is implemented:

    //::VkUnimplemented ( w, "MainForm::userSelected" );




    //---- End editable code block: MainForm userSelected

} // End MainForm::userSelected()


void MainForm::setParent( VkWindow  * parent )
{
    // Store a pointer to the parent VkWindow. This can
    // be useful for accessing the menubar from this class.


    _parent = parent;

} // End MainForm::setParent()


void MainForm::audioPanel( Widget w, XtPointer callData )
{

    //---- Start editable code block: MainForm audioPanel

    system("apanel &");

    //--- Comment out this line when this function is implemented:

    //::VkUnimplemented ( NULL, "MainForm::audioPanel" );

    //---- End editable code block: MainForm audioPanel

} // End MainForm::audioPanel()


void MainForm::chat( Widget w, XtPointer callData )
{

    //---- Start editable code block: MainForm chat

  _chat->show();

    //--- Comment out this line when this function is implemented:

  //::VkUnimplemented ( NULL, "MainForm::chat" );

    //---- End editable code block: MainForm chat

} // End MainForm::chat()


void MainForm::conf( Widget w, XtPointer callData )
{

    //---- Start editable code block: MainForm conf

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "MainForm::conf" );




    //---- End editable code block: MainForm conf

} // End MainForm::conf()


void MainForm::options( Widget w, XtPointer callData )
{

    //---- Start editable code block: MainForm options

  OptionsWindowMainWindow *options;
  options = new OptionsWindowMainWindow("Options", NULL, 0);
  options->show();

    //--- Comment out this line when this function is implemented:

  //::VkUnimplemented ( NULL, "MainForm::options" );

    //---- End editable code block: MainForm options

} // End MainForm::options()


void MainForm::overview( Widget w, XtPointer callData )
{

    //---- Start editable code block: MainForm overview

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "MainForm::overview" );




    //---- End editable code block: MainForm overview

} // End MainForm::overview()


void MainForm::reset( Widget w, XtPointer callData )
{

    //---- Start editable code block: MainForm reset

    //--- Comment out this line when this function is implemented:

  //::VkUnimplemented ( NULL, "MainForm::reset" );

  XmListDeleteAllItems(_usersList);
  setStatus("Session reset completed");


    //---- End editable code block: MainForm reset

} // End MainForm::reset()


void MainForm::statistics( Widget w, XtPointer callData )
{

    //---- Start editable code block: MainForm statistics

    StatWindowMainWindow *statistics;
    statistics = new StatWindowMainWindow("statistics", NULL, 0);
    statistics->show();

    //--- Comment out this line when this function is implemented:

    //::VkUnimplemented ( NULL, "MainForm::statistics" );

    //---- End editable code block: MainForm statistics

} // End MainForm::statistics()


void MainForm::users( Widget w, XtPointer callData )
{

    //---- Start editable code block: MainForm users

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "MainForm::users" );




    //---- End editable code block: MainForm users

} // End MainForm::users()





///////////////////////////////////////////////////////////////////
// C-callable creation function, for importing class into rapidapp
///////////////////////////////////////////////////////////////////


extern "C" VkComponent * CreateMainForm( const char *name, Widget parent ) 
{  
    VkComponent *obj =  new MainForm ( name, parent );
    obj->show();

    return ( obj );
} // End CreateMainForm


///////////////////////////////////////////////////////////////////
// Function for importing this class into rapidapp
// This function is only used by RapidApp.
///////////////////////////////////////////////////////////////////


typedef void (MainForm::*Method) (void);
struct FunctionMap {
  char  *resource;  Method method;  char  *code;
  char  *type;
};


extern "C" void* RegisterMainFormInterface()
{ 
    // This structure registers information about this class
    // that allows RapidApp to create and manipulate an instance.
    // Each entry provides a resource name that will appear in the
    // resource manager palette when an instance of this class is
    // selected, the relative address of the member function that
    // should be invoked when the resource is set, the name of the
    // member function as a string, and the type of the single 
    // argument to this function. All functions must have the form
    //  
    //  void memberFunction(Type);
    //
    // where "Type" is one of const char *, Boolean, or int. Use
    // XmRString, XmRBoolean, or XmRInt to describe the argument type


    static FunctionMap map[] = {
    //---- Start editable code block: MainFormUI resource table

      // { "resourceName", (Method) &MainForm::setAttribute, "setAttribute", XmRString},
    //---- End editable code block: MainFormUI resource table
      { NULL }, // MUST be NULL terminated
    };

    return map;
} // End RegisterMainFormInterface()






//---- End of generated code

//---- Start editable code block: End of generated code

void MainForm::addUserToList(char *user)
{
  XmString str;
  
  str = XmStringCreateSimple(user);
  XmListAddItem(_usersList, str, 0);
  XmStringFree(str);

}

void MainForm::delUserFromList(char *user)
{
  XmString str;
  
  str = XmStringCreateSimple(user);
  XmListDeleteItem(_usersList, str);
  XmStringFree(str);

}

void MainForm::setStatus(char *status)
{
  XmTextFieldSetString(_statusText, status);
}

void MainForm::activateButtons(Boolean active)
{
  XtSetSensitive(_acceptButton, active);
  XtSetSensitive(_rejectButton, active);
}

void MainForm::chatMessage(BV_Member *mbr, int tag, char *data, int size)
{
  _chat->chatMessage(mbr, tag, data, size);
}

void MainForm::setSpeakerLevel(int level)
{
  int value = 110 - (110*level/32768);
  _speakerMeter->setValue(value, 110);
}

void MainForm::setMicLevel(int level)
{
  int value = 110 - (110*level/32768);
  _micMeter->setValue(value, 110);
}

//---- End editable code block: End of generated code


